% ellipse_quadractic_to_standard.m
% 
% input: quadratic form (coefficent)
% output: 1. standard form: x0, y0, phi, a, b
%         2. sample of ellipse


num = size(pts,1);
%centroid = mean(boundary,1);
centroid = mean(pts,1);
%pts_centered = pts - ones(num,1) * centroid;
pts_centered = pts - ones(num,1) * [centroid(1) centroid(2)];

x = pts_centered(:,1);
y = pts_centered(:,2);

M = [x.^2 y.^2 x.*y x y ones(num,1)];
%M = [y.^2 x.^2 x.*y y x ones(num,1)];

A = M' * M;

[U S V] = svd(A);

coef = U(:,6)
coef = [4, 2, 1, -8, -2, 1];

a = coef(1)
b = coef(2)/2
c = coef(3)
d = coef(4)/2
f = coef(5)/2
g = coef(6)

delta = det([a b d; b c f; d f g])
J_capital = det([a b; b c])
I_capital = a+c
delta / I_capital 

x0 = (c*d-b*f) / (b*b-a*c)
y0 = (a*f-b*d) / (b*b-a*c)

if (b ~= 0)
  phi = 1/2 * (1/cot( (c-a)/(2*b)));
else 
  phi = 0;
end

t1 = 2 *(a*f*f+c*d*d+g*b*b-2*b*d*f-a*c*g);
if a ~= c
 t2 = (b*b-a*c)* ((c-a)* (1+4*b*b/(a-c)^2)^0.5 + (c+a));
else 
 t2 = (b*b-a*c)* (- (c+a));
end
axis_x = (abs(t1/t2))^0.5;

if a ~= c
  t3 = (b*b-a*c)* ((a-c)* (1+4*b*b/(a-c)^2)^0.5 + (c+a));
else 
  t3 = (b*b-a*c)* (- (c+a));
end
axis_y = (abs(t1/t3))^0.5;

R = [cos(phi) -sin(phi); sin(phi) cos(phi)];

% generate sample of ellipse
pts = zeros(360,2);
for theta_id = 1:360
  theta = theta_id /360 * 6.18;
  pts(theta_id,:) = inv(R) * [ axis_x*cos(theta) axis_y*sin(theta)]';
  pts(theta_id,:) = pts(theta_id,:) + [x0 y0];
end

pts = pts + ones(360, 1) * centroid_best;
%figure; imagesc(im); colormap(gray); axis off; hold on;
plot(pts(:,1), pts(:,2), 'r-');
