% fillgap
%
% input: a sequence of points (may have big gap between two consectuve points)
% output: a sequence of ``smooth" points (uniformly small gap)
% 
% 11/04/08


num = size(pts_final,1);
pts_t = [pts_final; pts_final(1,:)];

pts_out = pts_t(1,:);
% use Berstein polynomial
for i = 2 : num
 distance = norm(pts_t(i,:) - pts_t(i+1,:));
 if distance > 10
   t = 1/distance : 2/distance : 1; 
   a1 = (1-t).^2; a2 = 2 * t.* (1-t); a3 = t.^2;
   midpoint = (pts_t(i,:) + pts_t(i+1,:)) / 2;
   if midpoint < cols /2 % close to left boundary
     midpoint(1) = midpoint(1) - margin_to_imbound / 2 ;   
   else  % close to right boundary
     midpoint(1) = midpoint(1) + margin_to_imbound / 2;   
   end
   pts_insert = a1' * pts_t(i,:) + a2' * midpoint + a3' * pts_t(i+1,:);
%   a1 = (1-t); a2 = t;
%   pts_insert = a1' * pts_t(i,:) + a2' * pts_t(i+1,:);
%figure; imagesc(im); colormap(gray); hold on;  plot(pts_insert(:,1), pts_insert(:,2), 'r+'); hold on; plot(pts_insert(:,1), pts_insert(:,2), 'r-'); hold on;
%   plot(pts_t(i,1), pts_t(i,2), 'b+');  plot(midpoint(1), midpoint(2), 'b+');  plot(pts_t(i+1,1), pts_t(i+1,2), 'b+');
   pts_out = [pts_out; pts_insert];
 else 
   pts_out = [pts_out; pts_t(i+1,:)];
 end
end

if 0 == 1
distance = zeros(num,1);

for i = 1: num
  distance(i) = norm(pts_t(i,:) - pts_t(i+1,:));
end

idx_gap = find(distance>10);  % at most 2 elements

if isempty(idx_gap) 
  pts_out = pts_final;
else 

 idx_gap = [1; idx_gap; 1];
 pts_out = [];

 for i = 2 : size(idx_gap,1)-1
  t = 1: floor(distance(idx_gap(i)) /2); 
  t = t';
  num_insert = length(t);
  v = pts_t(idx_gap(i)+1,:) - pts_t(idx_gap(i),:);
  pts_insert = ones(num_insert,1) * pts_t(idx_gap(i),:) + t/num_insert * v;
  pts_out = [pts_out; pts_t(idx_gap(i-1): idx_gap(i), :); pts_insert];
 end
end

end
