% fitting.m
% 
% fit an ellipse model
% 
% 12/20/07

num = size(pts,1);
%centroid_tmp = mean(boundary,1);
%pts_centered = pts - ones(num,1) * centroid_tmp;
centroid_tmp = mean(pts,1);
pts_centered = pts - ones(num,1) * [centroid_tmp(1) centroid_tmp(2)];

x = pts_centered(:,1);
y = pts_centered(:,2);

M = [x.^2 y.^2 x.*y x y ones(num,1)];
%M = [y.^2 x.^2 x.*y y x ones(num,1)];

A = M' * M;

[U S V] = svd(A);

c = U(:,6);

c_t = sqrt(abs(1./c));
ratio_ellipse = max(abs(c_t(1)), abs(c_t(2))) / min(abs(c_t(1)), abs(c_t(2)));


% locate y based on x
x = min(pts_centered(:,1)): 1 : max(pts_centered(:,1));
x = x';
y_upper = zeros(length(x), 1);
y_lower = zeros(length(x), 1);
for i = 1: length(x)
  coeff1 = c(2);
  coeff2 = c(3) * x(i) + c(5);
  coeff3 = c(1) * x(i)^2 + c(4)*x(i) + c(6);
  delta = coeff2^2 - 4 * coeff1 * coeff3;
  y_upper(i) = (coeff2 + sqrt(delta)) / (2 * coeff1);
  y_lower(i) = (coeff2 - sqrt(delta)) / (2 * coeff1);
end

pts = [x y_upper] + ones(length(x),1) * [centroid_tmp(1), rows-centroid_tmp(2)];
pts(:,2) = rows-pts(:,2);
%figure; imagesc(im); colormap(gray); hold on; 
%plot(pts(:,1), pts(:,2), 'r-'); hold on;

pts_final = pts;

pts = [x y_lower] + ones(length(x),1) * [centroid_tmp(1), rows-centroid_tmp(2)];
pts(:,2) = rows-pts(:,2);
%plot(pts(:,1), pts(:,2), 'r-'); hold on;
%plot(boundary(:,1), boundary(:,2), 'k+'); 

pts_final = [pts_final; pts];


% y->x
if 0 == 0
y = min(pts_centered(:,2)): 1 : max(pts_centered(:,2));
y = y';
x_right = zeros(length(y), 1);
x_left = zeros(length(y), 1);
for i = 1: length(y)
  coeff1 = c(1);
  coeff2 = c(3) * y(i) + c(4);
  coeff3 = c(2) * y(i)^2 + c(5)*y(i) + c(6);
  delta = coeff2^2 - 4 * coeff1 * coeff3;
  x_right(i) = (coeff2 + sqrt(delta)) / (2 * coeff1);
  x_left(i) = (coeff2 - sqrt(delta)) / (2 * coeff1);
end


pts = [x_right y] + ones(length(y),1) * [cols-centroid_tmp(1), centroid_tmp(2)];
pts(:,1) = cols-pts(:,1);
%figure; imagesc(im); colormap(gray); hold on; 
%plot(pts(:,1), pts(:,2), 'ko'); hold on;
%plot(pts(:,1), pts(:,2), 'r-'); hold on;

pts_final = [pts_final; pts];

pts = [x_left y] + ones(length(y),1) * [cols-centroid_tmp(1), centroid_tmp(2)];
pts(:,1) = cols-pts(:,1);
%plot(pts(:,1), pts(:,2), 'ko'); hold on;
%plot(pts(:,1), pts(:,2), 'r-'); hold on;

%plot(pts_final(:,1), pts_final(:,2), 'k+'); 
%plot(pts_final(:,1), pts_final(:,2), 'b-'); 
pts_final = [pts_final; pts];

end % end of y->x

% finalize
K = convhull(pts_final(:,1), pts_final(:,2));
pts_final = [pts_final(K,1) pts_final(K,2)];
%figure; imagesc(im); colormap(gray); axis off; hold on; 
%plot(pts_final(:,1), pts_final(:,2), 'k-', 'LineWidth', 4); hold on;

