function contour_out = interpolate_contour(contour_in, n); 
%function contour_out = interpolate_contour(contour_in, n); 
%
% Function description: 
%     interpolate a ``low-resolution" contour using Cardinal spline
% 
% Input:  
%     contour_in --- a "low-resolution" contour
%     n          --- number of intervals (i.e. parametric curve would be evaluted n+1 times)
% Output: 
%     contour_out--- a "high-resolution" contour
%
% Qi Li
% 08/22/08

Tension=0; 
%n= 3;          % number of intervals (i.e. parametric curve would be evaluted n+1 times)


Py = contour_in(:,1);
Px = contour_in(:,2);

Py = [Py; contour_in(1:3,1)];
Px = [Px; contour_in(1:3,2)];

set1x=[];
set1y=[];
for k=1:length(Px)-3
    [xvec,yvec]=EvaluateCardinal2DAtNplusOneValues([Px(k),Py(k)],[Px(k+1),Py(k+1)],[Px(k+2),Py(k+2)],[Px(k+3),Py(k+3)],Tension,n);
    set1x=[set1x, xvec];
    set1y=[set1y, yvec];    
end


%set1x = [Px(1) set1x Px(length(Px)) Px(1)];
%set1y = [Py(1) set1y Py(length(Py)) Py(1)];

%plot(set1x,set1y,'g','linewidth',2); hold on;

contour_out = [set1y', set1x'];

