function [contour_out, rotation] = normalize_orientation(contour_in); 
% function contour_out = normalize_orientation(contour_in); 
%
% Function description: 
%     normalize a contour so that its orientation is horizontal.
% 
% Input:  
%     contour_in --- contour of any orientation, but with zero mean
% Output: 
%     contour_out--- contour of horizontal 
%     rotation   --- rotation matrix
%
% Qi Li
% 08/22/08


covarience= contour_in' * contour_in;

[U S V]=svd(covarience);

%angle=acosd(U(1,1));
contour_out = contour_in * U; 
rotation = U;

