%function inliers_best = remove_via_ransac(edgels, cols, rows)
% remove_via_ransac.m
%
% input: edgels
%        rows
%        cols 
% output: inliers_best
%
% 10/09/08

threshold_residue = 0.5;

num_edgels = size(edgels, 1);
num_inliers_largest = 0;

for i = 1: 1000

  % draw a sample of n=4 points
  sample_idx = floor(rand(1,4) * (num_edgels-1)) + 1;
  sample = edgels(sample_idx, :); 

  % fitting
  pts = sample;
  fitting;

  % compute residue
  pts = edgels;
  num= size(pts,1);
  centroid_tmp = mean(pts,1);
  pts_centered = pts - ones(num,1) * [centroid_tmp(1) centroid_tmp(2)];
  x = pts_centered(:,1);
  y = pts_centered(:,2);
  M = [x.^2 y.^2 x.*y x y ones(num,1)];

  residues = abs(M * c);
  idx_inliers = find(residues < threshold_residue);
  num_inliers = length(idx_inliers);
  inliers = edgels(idx_inliers,:);

  if (num_inliers > num_inliers_largest) 

     num_inliers_largest = num_inliers;
     c_best = c;
     centroid_best = centroid_tmp;
     inliers_best = inliers;
  end

end % end of ransac

%figure; plot(inliers_best(:,1), inliers_best(:,2), 'r+');

